from Gengo import *
import time
from tkinter import *
from tkinter import messagebox
tk=Tk();tk.title("元号表記暦")
canvas=Canvas(tk, width=400, height=300)
canvas.pack()
tk2=Tk();tk2.title("元号一覧")
canvas2=Canvas(tk2, width=500, height=380)
canvas2.pack()
tk2.withdraw(); mouseXY=[False,0,0]#ウインドウを隠してマウス操作無効
def drawGtext(X,Y,TXT, SIZE,CL):
    canvas2.create_text(X,Y,text=TXT,font=('HG教科書体',SIZE,'bold'),
                                tag='date',fill=CL)
def dspGengo():#元号一覧表示
    #tk2=Tk();tk2.title("元号一覧")
    #canvas2=Canvas(tk2, width=500, height=380)
    #canvas2.pack()
    tk2.deiconify(); mouseXY[0]=True #ウィンドウを表示してマウス操作有効
    canvas2.delete('date')  # 前表示の日付削除(タグ='date')
    Y=1; X=-80; k=0
    for i in range(len(GTab)):
        if k % 30 ==0: Y=12; X+=100 # 列変更
        if GTab[i][4]!="":          # 時代の表示
            DX=len(S)*10; drawGtext(X+DX+20,Y,GTab[i][4],8,'blue')
            Y+=11; k+=1
            if k % 30 ==0: Y=40; X+=100 # 列変更
        drawGtext(X   ,Y, GTab[i][3]       ,10,'black')#元号
        drawGtext(X+35,Y,"%4s" % GTab[i][0],10,'black')#年
        drawGtext(X+55,Y,"%4s" % GTab[i][1],10,'black')#月
        Y+=11; k+=1
def exitProc2():#元号一覧が閉じられようとしたときウィンドウを隠すだけにする
    mouseXY[0]=False; tk2.withdraw()
def updTxtB(txt,DT):
    txt.delete("1.0","1.100"); txt.insert(INSERT, "%d" % DT)
def leftMouseDown(event):#左ボタンクリックのときの処理
    if mouseXY[0]:#マウス操作有効のとき
        X=int((event.x)/100); Y=int((event.y-7)/11)
        if X<0 or X>5 or Y<0 or Y>29: return 
        N=X*30+Y; k=0
        for i in range(len(GTab)):
            if GTab[i][4] !="": k+=1 #時代名が表記されているとき行カウント
            if (k+i)==N:             #該当する元号のとき
                updTxtB(txtY,GTab[i][0]);updTxtB(txtM,GTab[i][1])
                if messagebox.askokcancel(
                    "暦表示",
                    "%s元年最初(%d/%d)の暦を表示しますか?" %
                    (GTab[i][3],GTab[i][0],GTab[i][1])):
                    dspCalendar()    #暦表示
                break
def setColor(WD):
    CL='black'
    if WD==0: CL='red'
    if WD==6: CL='blue'
    return CL
def drawDate(X,Y,i,CL):
    canvas.create_text(X,Y, text=("%2d" % i),fill=CL,
                       font=('Helvetica',15,"bold"),tag='date')
def drawStartGengo(X,Y):
    canvas.create_rectangle(X+15,Y,X+40,Y+20,
                            tag='date',fill='#FFFF77',
                            outline='#FF7777')
def simpleCalendar2(Y,M):
    canvas.delete('date')
    DayOfWeek=["Sun","Mon","Tue","Wed","Thu","Fri","Sat"]
    chGengo[0]=0; chGengo[1]=0
    canvas.create_text(180,30,text=strGengo(Y,M),
                       font=('HG教科書体',8,'bold'),
                       tag='date',fill='purple')
    Date=[0,0,0]; Date[0]=Y; Date[1]=M; Date[2]=1
    #canvas.create_text(60,10, text="%4d年%3d月" % (Y,M), tag='date')
    for i in range(7):
        CL=setColor(i)
        canvas.create_text(30+i*50,50, text=DayOfWeek[i],fill=CL,
                           font=('Times',10),tag='date')
    canvas.create_line(10,60,360,60,fill='black',tag='date')
    if Y<1582 or (Y==1582 and M<=10): DW=JWeekDayZ(Date)
    else : DW=GWeekDayZ(Date)
    if Y<1582 or (Y==1582 and M<10):  MX=JMDates(Date)
    else :  MX=GMDates(Date)
    j=1
    if Y==1582 and M==10:   # 1582年10月の1行目の特殊処理
        for i in range(DW,7):
            if j==5: j+=10  # 1582年10月5のとき10日ずらす
            drawDate(20+i*50,80,j,setColor(i))
            j+=1
    else :                  # 1582年10月以外の1行目の処理
        for i in range(DW,7):
            if j==chGengo[1]: drawStartGengo(i*50,70)
            drawDate(30+i*50,80,j,setColor(i))
            j+=1
    k=-1; YY=80
    for i in range(j,MX+1): # 2行目以降の処理
        k=(k+1) % 7
        if k==0: YY+=40
        if i==chGengo[1]:drawStartGengo(k*50,YY-10)
        drawDate(30+k*50,YY, i, setColor(k))
def dspCalendar():
    Y=int(txtY.get("1.0","1.4")) # 1行目4文字取り出し
    M=int(txtM.get("1.0","1.2")) # 1行目2文字取り出し
    simpleCalendar2(Y,M)

t=time.localtime() # 現在の日付取り出し
txtY=Text(tk, width=5,height=1);txtY.insert(INSERT,str(t[0]))
txtM=Text(tk, width=3,height=1);txtM.insert(INSERT,str(t[1]))
txtY.place(x =  200, y = 2);txtM.place(x = 270, y = 2)
lblY = Label(tk, text='年', fg='black');lblY.place(x =  240, y = 1)    
lblM = Label(tk, text='月', fg='black');lblM.place(x =  290, y = 1) 
btn1 = Button(tk, text='表示', height=1, command=dspCalendar,
              font=('HGSｺﾞｼｯｸE',10,'normal'))
btn1.place(x = 320, y = 1)
btn2 = Button(tk, text='元号', height=1, command=dspGengo,
              font=('HGSｺﾞｼｯｸE',10,'normal'))
btn2.place(x = 360, y = 1)
tk2.protocol("WM_DELETE_WINDOW",exitProc2) #ウィンドウが閉じられたときexitProcを呼び出し
canvas2.bind("<Button-1>",leftMouseDown)   #元号一覧のときの左ボタンクリック処理 
dspCalendar()
tk.mainloop()

